require "bitfifo/version"

class Bitfifo
  def self.reverse(data,nb)
    return nil if data.nil?
    data &= (1 << nb) - 1
    rtn = 0
    nb.times do |ii|
      rtn <<= 1
      rtn |= (data & 1)
      data >>= 1
    end
    rtn
  end

  def initialize
    @bits = 0
    @size = 0
    self
  end
  
  def to_i(reduce=true)
    if reduce
      size = @size
      rtn = get(size)
      unget(size)
      return rtn
    end
    return @bits
  end

  def put(data, nb=nil)
    if nb.nil?
      data=1 if data==true
      data=0 if data==false
      @bits <<= 1
      @bits |= data & 1
      @size += 1
    else
      mask = (1 << nb) - 1
      data &= mask
      @bits <<= nb
      @bits |= data
      @size += nb
    end
  end

  def get(nb=1)
    mask = (1 << nb) - 1
    rtn = (@bits & (mask << (@size-nb))) >> (@size-nb)
    @size -= nb
    if @size < 0
      @size=0
      return nil
    end
    rtn
  end
  
  def unget(nb=1)
    @size += nb
    self
  end
  
  def rput(data, nb=nil)
    return put(data) if nb.nil?
    put(self.class.reverse(data,nb),nb)
  end

  def rget(nb=1)
    self.class.reverse(get(nb),nb)
  end
  
  def size
    @size
  end

  def count
    @size
  end

  def empty
    rtn = @bits
    @bits = 0
    @size = 0
    rtn
  end 

  def empty?
    @size==0
  end
 
end
